#include <stdio.h>
#include "CBasisMemStats.h"
#include "CBasisTiming.h"
#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>

extern void ___asm_main(void);

int main(void)
{
    // Setup a stack size of 2GB, just to be sure...
    struct rlimit rl;
    rl.rlim_cur = 2000000000;
    rl.rlim_max = 2001000000;
    if(setrlimit(RLIMIT_STACK, &rl) != 0) {
	puts("Stack limit not set, exiting to prevent crashes");
        return -1;
    }
    //rl.rlim_cur = 0;
    //rl.rlim_max = 0;
    //getrlimit(RLIMIT_STACK, &rl);
    //printf("Rlimit cur %d max %d\n", (int)rl.rlim_cur, (int)rl.rlim_max);

    BtiSetup();
    BtiResetTimeStats();
    BmsResetStats();
    ___asm_main();
    BmsShowStats();
    BtiShowTimeStats();

    return 0;
}
