#include <stdio.h>

void ___print(char *str);

FILE **___TextIO_openOut(char *fileName);
void ___TextIO_closeOut(FILE **file);
void ___TextIO_output(FILE **file, int len, void *data);

void *___MemAlloc(int size);
void ___MemFree(void *addr);

// Clear all line marks, to initiate a full heap liveness trace
void ___MrClearLineMarks();

// The function that garbage collection is all about
void ___MrReclaimGarbage();

// Returns 1 if we should reclaim garbage, 0 otherwise
int ___MrShouldReclaimGarbage();

// Return the tracing-function clear-mask for either a full
// or a partial heap collection, depending on what it is time for
unsigned int ___MrFullOrPartialClearMask();

// Returns 1 if we should continue tracing back upwards the stack, 0 otherwise
int ___MrShouldStillTrace();
