#ifndef __CBASIS_TIMING_H__
#define __CBASIS_TIMING_H__

// Initialize the timer module
void BtiSetup();

void BtiResetTimeStats();
void BtiShowTimeStats();

void BtiStartPauseTimer();
long long BtiReadPauseTimerMicro();

// Start quick asynchronous timer in micro seconds
void BtiStartQuickAsyncTimerMicro(long microSeconds);

// A much quicker polling of whether the timer has fired than gettimeofday
int BtiIsQuickAsyncTimerFired();

#endif // __CBASIS_TIMING_H__
