#ifndef __CBASIS_INTERNAL_HEAP_MNG_H__
#define __CBASIS_INTERNAL_HEAP_MNG_H__

#include "CBasisMarkRegionConfig.h"

// Mark-region block size
#define IHM_BLOCK_SIZE   MRC_BLOCK_SIZE

// Allocate a given number of contiguous blocks, aligned to block size
void *IhmAllocAlignedBlocks(unsigned int blockCnt);

// Free a set of contiguous blocks allocated by IhmAllocAlignedBlocks
void IhmFreeAlignedBlocks(void *alignedAddr);

#endif // __CBASIS_INTERNAL_HEAP_MNG_H__
